<template>
  <div>
    <div :id="id" class="chart--nodata"></div>
    <div v-if="!charData.length" class="chart--nodata">
      <div>
        <img class="image-120" src="@/assets/no-data.svg" />
        <p class="font-14 color-606266 no-data-text">暂无数据</p>
      </div>
    </div>
  </div>

  <!-- <div v-if="charData.length" :id="id"></div> -->
  <!-- <div v-else class="chart--nodata"></div> -->
</template>

<script>
// import G2 from '@antv/g2';
import * as G2 from '@antv/g2';
export default {
  data() {
    return {
      chart: null
    };
  },
  props: {
    charData: {
      type: Array,
      default() {
        return [];
      }
    },
    id: String
  },
  mounted() {
    setTimeout(() => {
      this.drawChart(); // 第一步是创建的时候更新图表，但是这个不适用于异步请求接口获取相关数据，采用下面的监听的方式
    }, 30);
  },
  beforeUpdate() {
    this.drawChart();
  },
  watch: {
    charData() {
      this.drawChart();
    }
  },
  methods: {
    async drawChart() {
      this.chart && this.chart.destroy();
      if (!this.charData.length) return;
      this.chart = new G2.Chart({
        container: this.id,
        autoFit: true,
        forceFit: true,
        padding: [20, 40, 40, 20]
      });
      this.chart.data(this.charData);
      // 图例
      this.chart.legend({
        custom: true,
        position: 'top-left',
        items: [
          { name: '今日添加人数', value: 'addNum', marker: { symbol: 'line', style: { stroke: '#4B74E8', lineWidth: 12, lineHeight: 8 } } },
          { name: '今日点击人次', value: 'clickTimes', marker: { symbol: 'line', style: { stroke: '#D6B38C', lineWidth: 12, lineHeight: 8 } } },
          { name: '今日点击人数', value: 'clickNum', marker: { symbol: 'line', style: { stroke: '#14C9C9', lineWidth: 12, lineHeight: 8 } } }
        ]
      });
      const lineConfig = {
        grid: {
          line: {
            type: 'line',
            style: {
              stroke: '#E4E7ED',
              lineDash: [3, 3]
            }
          }
        },
        label: {
          style: {
            fill: '#606266'
          },
          formatter: val => {
            // 格式化参数值
            return val;
          }
        }
      };
      //坐标轴配置(法一配置)
      this.chart.axis('bizDate', lineConfig);
      this.chart.axis('addNum', lineConfig);
      this.chart.axis('clickTimes', lineConfig);
      this.chart.axis('clickNum', lineConfig);
      this.chart.tooltip({
        showCrosshairs: true,
        shared: true,
        itemTpl: `<div style="margin-bottom: 10px;list-style:none;">
            <span style="background-color:{color};" class="g2-tooltip-marker"></span>
            {name}: {value}
            </div>`
      });

      this.chart
        .line()
        .position('bizDate*addNum')
        .color('#4B74E8')
        .tooltip('addNum', addNum => {
          return {
            name: '今日添加人数',
            value: addNum
          };
        });

      this.chart
        .line()
        .position('bizDate*clickTimes')
        .tooltip('clickTimes', clickTimes => {
          return { name: '今日点击人次', value: clickTimes };
        })
        .color('#D6B38C');
      this.chart
        .line()
        .position('bizDate*clickNum')
        .tooltip('clickNum', clickNum => {
          return { name: '今日点击人数', value: clickNum };
        })
        .color('#14C9C9');

      this.chart.removeInteraction('legend-filter'); // 自定义图例，移除默认的分类图例筛选交互
      //图表绘制的最后一步，用于将图表渲染至画布
      this.chart.render();
    }
  }
};
</script>
<style lang="scss" scoped>
.chart--nodata {
  height: 359px;
  width: 100%;
  display: flex;
  justify-content: center;
  .image-120 {
    width: 120px;
    height: 120px;
    padding-top: 60px;
  }
  .no-data-text {
    text-align: center;
    padding-top: 18px;
  }
}
</style>
